/***!Start!***
 *
 *   ORIGINS: 27
 *
 *     25H7912  (C)   COPYRIGHT International Business Machines Corp. 1992,1996
 *   All Rights Reserved
 *   Licensed Materials - Property of IBM
 *   The source code for this program is not published or otherwise divested
 *   of its trade secrets, irrespective of what has been deposited with the
 *   U.S. Copyright Office.
 *
 ***!End!***/

/*
 *    @(#) 1.13 src/somu/somuutil.h, somu.config, som3.0 5/3/96 15:41:29 [12/22/96 21:30:30]
 *
 *  Public header files for the SOM config file utilities.
 */
#ifndef SOMUUTIL_H
#define SOMUUTIL_H 1

#include <som.h>


#if defined(__IBMC__) && defined(__OS2__)
 #pragma linkage(somutgetenv       , system)
 #pragma linkage(somutgetshellenv  , system)
 #pragma linkage(somutresetenv     , system)
 #pragma linkage(somutgetpath       , system)
#endif

SOMEXTERN char * SOMLINK somutgetenv(char *envvar, char *stanza);
SOMEXTERN char * SOMLINK somutgetshellenv(char *envvar, char *stanza);
SOMEXTERN void  SOMLINK somutresetenv(char *newenv);
SOMEXTERN int   SOMLINK somutgetpath(char *path);

#endif
