@echo off
rem @(#) 1.18 src/somc/comp/somcorba.bat, somc.utils, som3.0 12/17/96 18:33:59 [12/22/96 21:25:46]

rem COMPONENT_NAME: some
rem
rem ORIGINS: 27
rem
rem
rem  25H7912  (C)  COPYRIGHT International Business Machines Corp. 1992,1996,1996  
rem All Rights Reserved
rem Licensed Materials - Property of IBM
rem US Government Users Restricted Rights - Use, duplication or
rem disclosure restricted by GSA ADP Schedule Contract with IBM Corp.

rem Command script to convert to implict stars (like CORBA) for
rem interface references.

rem SETLOCAL
IF "%SOMBASE%"=="" GOTO sombase
IF "%SC%"=="" GOTO somsc

IF "%SOMDRIVE%"=="" GOTO body
%SOMDRIVE%

:body

IF NOT EXIST %SOMBASE%\include\somcorba.gen goto normal
echo.
echo You chose to have the C bindings generated in the SOMobjects
echo package you last installed.  This process will take
echo between 5-30 minutes to complete depending on your system
echo and install options.  Please be patient - this process will not
echo be run again unless you install some new SOM components.
echo.

:normal
echo Generating the CORBA C Bindings:
CD %SOMBASE%\include
IF NOT EXIST som.hc GOTO drive:
ATTRIB -R som.h
rem ATTRIB -R gen_c.efw
rem ATTRIB -R gen_ew16.efw
rem ATTRIB -R gen_mw16.efw
COPY som.hc       som.h > NUL
rem COPY gen_c.efc    gen_c.efw  > NUL
rem COPY gen_ew16.efc gen_ew16.efw  > NUL
rem COPY gen_mw16.efc gen_mw16.efw > NUL
IF EXIST somstars.bld DEL somstars.bld
SET SMADDSTAR=
%SC% -%% -mnoaddstar -mwinmult -mnochk -sh *.idl
IF NOT ERRORLEVEL 0 GOTO end
echo somcorba.bld  > somcorba.bld
IF EXIST somdtype.idl %SC% -mnoaddstar -mwinmult -mnochk -sh -DEMIT_SOMDTYPES somdtype.idl
IF EXIST somcorba.gen DEL somcorba.gen
GOTO end

:sombase
    ECHO SOMBASE should be set before running somcorba.
    GOTO end

:somsc
    ECHO SC should be set before running somcorba.
    GOTO end

:drive
    ECHO SOM is not installed on the current drive, please set SOMDRIVE.

:end
    rem ENDLOCAL
